Subject: Re: [bug report] net/mlx5e: E-Switch, Maintain vhca_id to vport_num mapping

From: Leon Romanovsky <[email-masked]>
Date: Wed, 10 Feb 2021 13:48:20 +0200

On Wed, Feb 10, 2021 at 11:51:51AM +0300, Dan Carpenter wrote:
> Hello Vlad Buslov,
>
> The patch 84ae9c1f29c0: "net/mlx5e: E-Switch, Maintain vhca_id to
> vport_num mapping" from Sep 23, 2020, leads to the following static
> checker warning:
>
> 	drivers/net/ethernet/mellanox/mlx5/core/vport.c:1170 mlx5_vport_get_other_func_cap()
> 	warn: odd binop '0x0 & 0x1'
>
> drivers/net/ethernet/mellanox/mlx5/core/vport.c
>   1168  int mlx5_vport_get_other_func_cap(struct mlx5_core_dev *dev, u16 function_id, void *out)
>   1169  {
>   1170          u16 opmod = (MLX5_CAP_GENERAL << 1) | (HCA_CAP_OPMOD_GET_MAX & 0x01);
>
> HCA_CAP_OPMOD_GET_MAX is zero.  The 0x01 is a magical number.
>
>   1171          u8 in[MLX5_ST_SZ_BYTES(query_hca_cap_in)] = {};
>   1172
>   1173          MLX5_SET(query_hca_cap_in, in, opcode, MLX5_CMD_OP_QUERY_HCA_CAP);
>   1174          MLX5_SET(query_hca_cap_in, in, op_mod, opmod);
>   1175          MLX5_SET(query_hca_cap_in, in, function_id, function_id);
>   1176          MLX5_SET(query_hca_cap_in, in, other_function, true);
>   1177          return mlx5_cmd_exec_inout(dev, query_hca_cap, in, out);
>   1178  }

Dan,

I'm running smatch which is based on 6193b3b71beb ("extra: fix some error pointer handling")
and I don't see this error. Should I run something special?

Thanks

> regards,
> dan carpenter